#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>

#define width_size 300
#define height_size 420
#define HISTOGRAM_SIZE 256 
#define white 255
#define black 0

GLubyte *frameBuf = NULL;
GLubyte	Matrix_Picture[height_size][width_size];
GLubyte Matrix_Lena[420][300];
GLubyte	Ordered_Dithering[4][4];
GLubyte	Dispersed_Dithering[4][4];
GLubyte	Floyd_Steinberg[3][3];


int Lena_Picture[126000];
int Histogram_Values[HISTOGRAM_SIZE];
int limiar_value[16];
int i, j, m, n, l=0;



void histogram()
{ 
	
long int counter = 0;

while (counter < HISTOGRAM_SIZE) {
	
	Histogram_Values[counter]=0;
  counter++;
}

counter = 0;

while (counter < HISTOGRAM_SIZE) {
   
	for (i=0; i < 126000; i++)
	{
	  if (Lena_Picture[i] == counter)
		{
      Histogram_Values[counter]=Histogram_Values[counter]+1;
		}
			
	}
  counter++;
}

counter = 0;
int Sum =0;

while (counter < HISTOGRAM_SIZE) {
	
	Sum = Sum + Histogram_Values[counter];
  counter++;
}

int hist_interval;

hist_interval = Sum / 18;

counter = 0;
int limiar=0, inc=0; 

while (counter < HISTOGRAM_SIZE) {
	
	limiar = limiar + Histogram_Values[counter];
  
	if(limiar > hist_interval)
	{
		limiar_value[inc]= counter;
		inc++;
		limiar =0;
	}

	counter++;
}

}

void read_picture_file(char *filename)
{
	const int MAX=5;
	char buff[MAX];

	ifstream fin(filename);

	while(fin)
		{
		fin >> buff;
		Lena_Picture[l] = atoi(buff);
		l++;
	}
	
	l=0;

  for (i=0; i < 420; i++)
	{
		for (j=0; j < 300; j++)
		{
			m = i*300 + j;

			Matrix_Lena[i][j] = (GLubyte) Lena_Picture[126000-m]; // NOT TO STAY UP-SIDE-DOWN
			l++;
		}
	}
	histogram();
}

void init(void) 
{

	glHistogram(GL_HISTOGRAM, HISTOGRAM_SIZE, GL_LUMINANCE, GL_FALSE);
  glEnable(GL_HISTOGRAM);
	glClearColor (1.0, 1.0, 1.0, 0.0);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();

	glRasterPos2i(200, 200);
	glDrawPixels(300, 420, GL_LUMINANCE, GL_UNSIGNED_BYTE, Matrix_Lena);
	glFlush();


  glReadPixels(200, 200, 300, 420, GL_RED, GL_UNSIGNED_BYTE, (GLubyte*) frameBuf);

  for (i=0; i < 420; i++)
	{
		for (j=0; j < 300; j++)
		{
			m = i*300 + j;

			Matrix_Picture[i][j] = (GLubyte) frameBuf[m];
		}
	}
	
	// PLOT HISTOGRAM	
	glColor3f(1.0, 0.0, 0.0);
	glLineWidth(1.5);
	int step = width_size;

  glBegin(GL_LINES);

  for(i = 0; i < HISTOGRAM_SIZE; i++)
  {
    step = step + 2;
		glVertex2i(i*step/(HISTOGRAM_SIZE-1), 0);
    glVertex2i(i*step/(HISTOGRAM_SIZE-1), Histogram_Values[i]/10.0);
	}
  glEnd();

/*
 type == 1 -> Limiarization	
 type == 2 -> Ordered Dithering	
 type == 3 -> Dispersed Dithering	
 type == 4 -> Floyd - Steinberg

1. |130|	 2. | 12 11 10 09 |       3.  | 01 09 03 11 |     4.  |  0      0      0   |
              | 13 01 02 08 |           | 13 05 15 07 |         |  0      0     7/16 |
		         	| 14 04 03 07 |           | 04 12 02 10 |         | 3/16   5/16   1/16 |
		        	| 15 16 05 06 |           | 16 08 14 06 |           
*/

int type = 4;

switch (type)
{


case 1:
	{
  for (i=0; i < 420; i=i++)
	{
		for (j=0; j < 300; j=j++)
		{
			if (Matrix_Picture[i][j] > (130))
				Matrix_Picture[i][j] = 255;
			else
				Matrix_Picture[i][j] = 0;
		}
	}
	}

case 2:
	{
    Ordered_Dithering[0][0] = limiar_value[11];
		Ordered_Dithering[0][1] = limiar_value[10];
	  Ordered_Dithering[0][2] = limiar_value[9];
		Ordered_Dithering[0][3] = limiar_value[8];
    Ordered_Dithering[1][0] = limiar_value[12];
		Ordered_Dithering[1][1] = limiar_value[0];
	  Ordered_Dithering[1][2] = limiar_value[1];
		Ordered_Dithering[1][3] = limiar_value[7];
    Ordered_Dithering[2][0] = limiar_value[13];
		Ordered_Dithering[2][1] = limiar_value[3];
	  Ordered_Dithering[2][2] = limiar_value[2];
		Ordered_Dithering[2][3] = limiar_value[6];
    Ordered_Dithering[3][0] = limiar_value[14];
		Ordered_Dithering[3][1] = limiar_value[15];
	  Ordered_Dithering[3][2] = limiar_value[4];
		Ordered_Dithering[3][3] = limiar_value[5];

  for (i=0; i < 420; i=i+4)
	{
		for (j=0; j < 300; j=j+4)
		{
			if (Matrix_Picture[i][j] > Ordered_Dithering[0][0])
				Matrix_Picture[i][j] = 255;
			else
				Matrix_Picture[i][j] = 0;

			if (Matrix_Picture[i][j+1] > Ordered_Dithering[0][1])
				Matrix_Picture[i][j+1] = 255;
			else
				Matrix_Picture[i][j+1] = 0;

			if (Matrix_Picture[i][j+2] > Ordered_Dithering[0][2])
				Matrix_Picture[i][j+2] = 255;
			else
				Matrix_Picture[i][j+2] = 0;
			
			if (Matrix_Picture[i][j+3] > Ordered_Dithering[0][3])
				Matrix_Picture[i][j+3] = 255;
			else
				Matrix_Picture[i][j+3] = 0;

      /*-----*/
			
			if (Matrix_Picture[i+1][j] > Ordered_Dithering[1][0])
				Matrix_Picture[i+1][j] = 255;
			else
				Matrix_Picture[i+1][j] = 0;

			if (Matrix_Picture[i+1][j+1] > Ordered_Dithering[1][1])
				Matrix_Picture[i+1][j+1] = 255;
			else
				Matrix_Picture[i+1][j+1] = 0;

			if (Matrix_Picture[i+1][j+2] > Ordered_Dithering[1][2])
				Matrix_Picture[i+1][j+2] = 255;
			else
				Matrix_Picture[i+1][j+2] = 0;

			if (Matrix_Picture[i+1][j+3] > Ordered_Dithering[1][3])
				Matrix_Picture[i+1][j+3] = 255;
			else
				Matrix_Picture[i+1][j+3] = 0;

      /*-----*/

			if (Matrix_Picture[i+2][j] > Ordered_Dithering[2][0])
				Matrix_Picture[i+2][j] = 255;
			else
				Matrix_Picture[i+2][j] = 0;

			if (Matrix_Picture[i+2][j+1] > Ordered_Dithering[2][1])
				Matrix_Picture[i+2][j+1] = 255;
			else
				Matrix_Picture[i+2][j+1] = 0;

			if (Matrix_Picture[i+2][j+2] > Ordered_Dithering[2][2])
				Matrix_Picture[i+2][j+2] = 255;
			else
				Matrix_Picture[i+2][j+2] = 0;

			if (Matrix_Picture[i+2][j+3] > Ordered_Dithering[2][3])
				Matrix_Picture[i+2][j+3] = 255;
			else
				Matrix_Picture[i+2][j+3] = 0;

			/*-----*/

			if (Matrix_Picture[i+3][j] > Ordered_Dithering[3][0])
				Matrix_Picture[i+3][j] = 255;
			else
				Matrix_Picture[i+3][j] = 0;

			if (Matrix_Picture[i+3][j+1] > Ordered_Dithering[3][1])
				Matrix_Picture[i+3][j+1] = 255;
			else
				Matrix_Picture[i+3][j+1] = 0;

			if (Matrix_Picture[i+3][j+2] > Ordered_Dithering[3][2])
				Matrix_Picture[i+3][j+2] = 255;
			else
				Matrix_Picture[i+3][j+2] = 0;

			if (Matrix_Picture[i+3][j+3] > Ordered_Dithering[3][3])
				Matrix_Picture[i+3][j+3] = 255;
			else
				Matrix_Picture[i+3][j+3] = 0;
		
		}

	}

  glRasterPos2i(600, 200);

  glDrawPixels(300, 420, GL_LUMINANCE, GL_UNSIGNED_BYTE, Matrix_Picture);

	}

case 3:
	{
    Dispersed_Dithering[0][0] = limiar_value[0];
		Dispersed_Dithering[0][1] = limiar_value[8];
	  Dispersed_Dithering[0][2] = limiar_value[2];
		Dispersed_Dithering[0][3] = limiar_value[10];
    Dispersed_Dithering[1][0] = limiar_value[12];
		Dispersed_Dithering[1][1] = limiar_value[4];
	  Dispersed_Dithering[1][2] = limiar_value[14];
		Dispersed_Dithering[1][3] = limiar_value[6];
    Dispersed_Dithering[2][0] = limiar_value[3];
		Dispersed_Dithering[2][1] = limiar_value[11];
	  Dispersed_Dithering[2][2] = limiar_value[1];
		Dispersed_Dithering[2][3] = limiar_value[9];
    Dispersed_Dithering[3][0] = limiar_value[15];
		Dispersed_Dithering[3][1] = limiar_value[7];
	  Dispersed_Dithering[3][2] = limiar_value[13];
		Dispersed_Dithering[3][3] = limiar_value[5];

  for (i=0; i < 420; i=i+4)
	{
		for (j=0; j < 300; j=j+4)
		{
			if (Matrix_Picture[i][j] > Dispersed_Dithering[0][0])
				Matrix_Picture[i][j] = 255;
			else
				Matrix_Picture[i][j] = 0;

			if (Matrix_Picture[i][j+1] > Dispersed_Dithering[0][1])
				Matrix_Picture[i][j+1] = 255;
			else
				Matrix_Picture[i][j+1] = 0;

			if (Matrix_Picture[i][j+2] > Dispersed_Dithering[0][2])
				Matrix_Picture[i][j+2] = 255;
			else
				Matrix_Picture[i][j+2] = 0;
			
			if (Matrix_Picture[i][j+3] > Dispersed_Dithering[0][3])
				Matrix_Picture[i][j+3] = 255;
			else
				Matrix_Picture[i][j+3] = 0;

			/*-----*/

			if (Matrix_Picture[i+1][j] > Dispersed_Dithering[1][0])
				Matrix_Picture[i+1][j] = 255;
			else
				Matrix_Picture[i+1][j] = 0;

			if (Matrix_Picture[i+1][j+1] > Dispersed_Dithering[1][1])
				Matrix_Picture[i+1][j+1] = 255;
			else
				Matrix_Picture[i+1][j+1] = 0;

			if (Matrix_Picture[i+1][j+2] > Dispersed_Dithering[1][2])
				Matrix_Picture[i+1][j+2] = 255;
			else
				Matrix_Picture[i+1][j+2] = 0;

			if (Matrix_Picture[i+1][j+3] > Dispersed_Dithering[1][3])
				Matrix_Picture[i+1][j+3] = 255;
			else
				Matrix_Picture[i+1][j+3] = 0;

			/*-----*/

			if (Matrix_Picture[i+2][j] > Dispersed_Dithering[2][0])
				Matrix_Picture[i+2][j] = 255;
			else
				Matrix_Picture[i+2][j] = 0;

			if (Matrix_Picture[i+2][j+1] > Dispersed_Dithering[2][1])
				Matrix_Picture[i+2][j+1] = 255;
			else
				Matrix_Picture[i+2][j+1] = 0;

			if (Matrix_Picture[i+2][j+2] > Dispersed_Dithering[2][2])
				Matrix_Picture[i+2][j+2] = 255;
			else
				Matrix_Picture[i+2][j+2] = 0;

			if (Matrix_Picture[i+2][j+3] > Dispersed_Dithering[2][3])
				Matrix_Picture[i+2][j+3] = 255;
			else
				Matrix_Picture[i+2][j+3] = 0;

			/*-----*/

			if (Matrix_Picture[i+3][j] > Dispersed_Dithering[3][0])
				Matrix_Picture[i+3][j] = 255;
			else
				Matrix_Picture[i+3][j] = 0;

			if (Matrix_Picture[i+3][j+1] > Dispersed_Dithering[3][1])
				Matrix_Picture[i+3][j+1] = 255;
			else
				Matrix_Picture[i+3][j+1] = 0;

			if (Matrix_Picture[i+3][j+2] > Dispersed_Dithering[3][2])
				Matrix_Picture[i+3][j+2] = 255;
			else
				Matrix_Picture[i+3][j+2] = 0;

			if (Matrix_Picture[i+3][j+3] > Dispersed_Dithering[3][3])
				Matrix_Picture[i+3][j+3] = 255;
			else
				Matrix_Picture[i+3][j+3] = 0;
		
		}

	}

  glRasterPos2i(600, 200);

  glDrawPixels(300, 420, GL_LUMINANCE, GL_UNSIGNED_BYTE, Matrix_Picture);

	}


case 4:
	{
// left to rigth & up to down

		int threshold = (white + black)/2;
    int error;

		for(i=0; i < 420; i++)
		{
			for(j=0; j < 300; j++)
			{
				if (Matrix_Picture[i][j] < threshold)
				{
					error = Matrix_Picture[i][j] - black;
					Matrix_Picture[i][j] = black;
				}
				else 
				{
					error = Matrix_Picture[i][j] - white;
					Matrix_Picture[i][j] = white;
				}

				if(i+1<420 && i+1>=0)

			  	Matrix_Picture[i+1][j]   += (7/16)*error;

				if(i+1<420 && i+1>=0 && j+1<300)

			  	Matrix_Picture[i+1][j+1] += (1/16)*error;

				if(j+1<300)

			    Matrix_Picture[i][j+1]   += (5/16)*error;

				if(i-1>=0 && j+1<300)

			  	Matrix_Picture[i-1][j+1] += (3/16)*error;

			}
		}
		
		
  glRasterPos2i(600, 200);

  glDrawPixels(300, 420, GL_LUMINANCE, GL_UNSIGNED_BYTE, Matrix_Picture);


	}

  }
  glPopMatrix();

	glutSwapBuffers();

}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0, (GLdouble) w, 0.0, (GLdouble) h);
  glMatrixMode (GL_MODELVIEW);
}

void main(int argc, char** argv) {
	
	read_picture_file("lena2.txt");
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(1000,700);
	glutInitWindowPosition(10,10);
	glutCreateWindow("Projeto 2");
	init();
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	frameBuf = (GLubyte*) malloc(sizeof(GLubyte)*300*420);
	glutMainLoop();

  if(frameBuf)
  {
    free(frameBuf);
    frameBuf = NULL;
  }

}
